#include <iostream>
using namespace std;


template < typename T, typename U = T > 
class myPair {
  T x_;
  U y_;
public:
  myPair(T x, U y) : x_(x), y_(y) {};
  T get_x() { return x_; }
  U get_y() { return y_; }
};

// L'unico operatore ternario del c++!
// ( che NON si puo' overloadare )
// expr ? a : b
// ---> if (expr) a; else b;

// specializzazione TOTALE
template<>  // nessun parametro residuo
class myPair<bool,bool> {
  char pack_;
public:
  myPair(bool b1, bool b2) : pack_( (b1?1:0) + (b2?2:0) ) {};
  // le due funzioni get (...)
  char pack() { return pack_; }
};

// specializzazione PARZIALE
// T == string , U generico
template<typename U>
class myPair<string,U> {
public:
  myPair() { cout << "STRING" << endl;}
};

// specializzazione parziale (versione 2)
// T e U sono PUNTATORI a tipi generici
template<typename T, typename U>
class myPair<T*,U*> {
  T * x_;
  U * y_;
public:
  myPair(T * x, U * y) : x_(x), y_(y) {};
  T & get_x() { return * x_; }
  U & get_y() { return * y_; }
};


int main() {
  //myPair<bool> pb(false,true);
  //cout << static_cast<short>(pb.pack()) << endl;
  //myPair<string,int> p;
  
  int * pi = new int(4);
  myPair<int*,int*> p(pi, pi);
  cout << p.get_x() << endl;
  delete pi;
  
}
